#ifndef MDD_INPUT_H
#define MDD_INPUT_H

#include <string>
#include <functional>
#include "Output.h"
#include <bits/shared_ptr.h>

namespace mdd {
    struct Input {
        std::string type;
        json value;
        std::function<bool(const json &)> verification;
        std::shared_ptr <IOutput> output;

        Input(const std::string &type, const json &default_value,
              const std::function<bool(const json &)> &verification = [](
                      const json &) { return true; });
    };
}

#endif //MDD_INPUT_H
