#ifndef MDD_PROCESSORBASE_H
#define MDD_PROCESSORBASE_H

#include "Input.h"
#include "IProcessor.h"
#include "HandlerModule.h"


namespace mdd {
    class ProcessorBase : IProcessor{
        std::vector<HandlerModule> _inputs;
        std::vector<HandlerModule> _outputs;
        std::vector<std::shared_ptr<IModule>> _modules;
    public:
        int addModule(std::shared_ptr<IModule> module) override ;
        int addInput(int moduleHandler, int inputHandler);
        json& setInputDefaultValue(int handle) override;
        const json& getInputValue(int handle) override;
        bool connectInput(int handle, std::shared_ptr<IOutput> output) override;
        std::vector<std::string> getInputs() override;
        std::vector<std::string> getOutputs() override;
        std::shared_ptr<IOutput> getOutput(int handle) override;
        int addOutput(int moduleHandler, int outputHandler);
    };
}
#endif
