#include "Output.h"
namespace mdd {
    Output::Output( const std::string& type, const json& initial) :
            _changed(false)
    {
        _type= type;
        _value = initial;
    }

    const json& Output::getValue() { return _value; }

    json& Output::getValueInternal() {
        _changed = true;
        return _value;
    }

    std::string Output::getType() { return _type; }

    bool Output::hasChanges() { return _changed; }

    void Output::resetChange() { _changed = false; }
}