#include "ProcessorBase.h"



namespace mdd{
    int ProcessorBase::addModule(std::shared_ptr<IModule> module){
        _modules.emplace_back(module);
        return _modules.size()-1;
    }

    int ProcessorBase::addInput(int moduleHandler, int inputHandler){
        _inputs.emplace_back(HandlerModule(moduleHandler, inputHandler));
        return _inputs.size()-1;
    }

    json& ProcessorBase::setInputDefaultValue(int handle){
        _modules[_inputs[handle].moduleHandler]->setInputDefaultValue(_inputs[handle].accessHandler);
    }

    const json& ProcessorBase::getInputValue(int handle){
        _modules[_inputs[handle].moduleHandler]->getInputValue(_inputs[handle].accessHandler);
    }

    bool ProcessorBase::connectInput(int handle, std::shared_ptr<IOutput> output){
        return _modules[_inputs[handle].moduleHandler]->connectInput(_inputs[handle].accessHandler, output);
    }

    std::vector<std::string> ProcessorBase::getInputs(){
        std::vector<std::string> ret;
        for (auto &input  : _inputs) {
            ret.push_back(_modules[input.moduleHandler]->getOutput(input.accessHandler)->getType());
        }
        return ret;
    }

    std::vector<std::string> ProcessorBase::getOutputs(){
        std::vector<std::string> ret;
        for (auto &output  : _outputs) {
            ret.push_back(_modules[output.moduleHandler]->getOutput(output.accessHandler)->getType());
        }
        return ret;
    }

    std::shared_ptr<IOutput> ProcessorBase::getOutput(int handle){
        _modules[_outputs[handle].moduleHandler]->getOutput(_outputs[handle].accessHandler);
    }

    int ProcessorBase::addOutput(int moduleHandler, int outputHandler){
        _outputs.emplace_back(HandlerModule(moduleHandler, outputHandler));
        return _outputs.size()-1;
    }
}